package cn.ibizlab.businesscentral.core.runtime.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.businesscentral.core.runtime.domain.Queue;
import cn.ibizlab.businesscentral.core.runtime.filter.QueueSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[Queue] 服务对象接口
 */
public interface IQueueService extends IService<Queue>{

    boolean save(Queue et) ;
    void saveBatch(List<Queue> list) ;
    Queue get(String key) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    boolean update(Queue et) ;
    void updateBatch(List<Queue> list) ;
    boolean create(Queue et) ;
    void createBatch(List<Queue> list) ;
    Queue getDraft(Queue et) ;
    boolean checkKey(Queue et) ;
    Page<Queue> searchDefault(QueueSearchContext context) ;
    List<Queue> selectByBusinessunitid(String businessunitid) ;
    void removeByBusinessunitid(String businessunitid) ;
    List<Queue> selectByTransactioncurrencyid(String transactioncurrencyid) ;
    void removeByTransactioncurrencyid(String transactioncurrencyid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<Queue> getQueueByIds(List<String> ids) ;
    List<Queue> getQueueByEntities(List<Queue> entities) ;

}


